//
// shatbox (C) 2002 Matthew Conte (matt@conte.com)
//
//
// cpu.h
//
// cpu unit
//
// $Id: $
//

#ifndef _CPU_H_
#define _CPU_H_

#include "typedefs.h"
#include "nes6502.h"
#include "unit.h"

class machine;
class cpu : public unit
{
public:
   cpu(machine *pMachine);
   virtual ~cpu();

   virtual void reset(bool hardReset);

   void  nmi();
   void  irq();
   uint8 dma(uint32 address);

   void  vbl();
   void  scanline();

   // bleh.
   void  setFrameIRQ(uint8 value);

   void  addTraps(unit *pUnit);
   void  closeTraps();

private:
   enum
   {
      MAX_MEM_HANDLER = 31,
   };

   uint8 *mpRAM;
   float mCurrentCycles;
   nes6502_memread   mReadTrap[MAX_MEM_HANDLER + 1];
   nes6502_memwrite  mWriteTrap[MAX_MEM_HANDLER + 1];

   int   addReadTrap(const nes6502_memread *pReadTrap, unit *pUnit);
   int   addWriteTrap(const nes6502_memwrite *pWriteTrap, unit *pUnit);

   int   runCycles(int cycles);
};

#endif // !_CPU_H_
