//
// shatbox (C) 2002 Matthew Conte (matt@conte.com)
//
//
// event.h
//
// event routines
//
// $Id: $
//

#ifndef _EVENT_H_
#define _EVENT_H_

enum
{
   PAD_A = 0,
   PAD_B,
   PAD_SELECT,
   PAD_START,
   PAD_UP,
   PAD_DOWN,
   PAD_LEFT,
   PAD_RIGHT
};

enum
{
   EVENT_NONE = 0,
   EVENT_QUIT,
   EVENT_RESET,
   EVENT_UNTHROTTLE,
   EVENT_PAD0_PRESS,
   EVENT_PAD0_RELEASE,
   EVENT_PAD1_PRESS,
   EVENT_PAD1_RELEASE,
   EVENT_STATE_SAVE,
   EVENT_STATE_LOAD,
};


struct event
{
   int type;
   unsigned int data;
};


class machine;
class eventHandler
{
public:
   eventHandler(machine *pMachine);

   int  process();
   void post(event *pEvent);

private:
   enum
   {
      MAX_EVENT   = 32,
   };

   machine *mpMachine;
   event mQueue[MAX_EVENT];
   int   mHead;
   int   mTail;
};

#endif // !_EVENT_H_
